#ifndef _BTREE_H
#define _BTREE_H

#include <stdio.h>

#include "Trie.h"
#include "Array.h"
#include "Hash.h"

#define MaxHeight 8

class BNindex {
 public:
  keyType index;
  class BtreeNode* child;
};

class BtreeNode {
  friend class Btree;

  int branch;
  BNindex *bni;

 public:
  BtreeNode(int btreearyIn, BtreeNode** Bnp, keyType* kt, int num) {
    bni=new BNindex[btreearyIn];
    register int i;
    branch=num;
    for (i=0; i<num; i++) bni[i].child=Bnp[i];
    for (i=0; i<num-1; i++) bni[i].index=kt[i];
  }

  BtreeNode(int btreearyIn, BtreeNode* bn) {
    bni=new BNindex[btreearyIn];
    branch=1;
    bni[0].child=bn;
  }

  void add(keyType key, BtreeNode* bn) {
    bni[branch-1].index=key;
    bni[branch++].child=bn;
  }

  void toHtable(HashTable*, int);
};

class Btree : public TrieNode {
  friend class HashTable;

  int btreeary;
  int height;
  BtreeNode* root;

  BtreeNode* traversalPtr[MaxHeight];	// used for traversal
  short traversalInt[MaxHeight];	// used for traversal

 public:
  Btree(int btreearyIn) {
    btreeary=btreearyIn;
    elementType *tmp=new elementType(-1);
    height=1;
    root=new BtreeNode(btreeary, (BtreeNode*)tmp);
    size=1;
  }

  Btree(int, Array*);

  int getHeight() { return height; }

  Identity getId() { return btree; }
  elementType* Insert(keyType);
  Boolean Delete(keyType);
  elementType* Search(keyType);
  elementType* getFirst();
  elementType* getNext();

  toHtable(HashTable* htbl) {
    root->toHtable(htbl, height-1);
  }
};
  
#endif
